import os, sys
import coral
import cherrypy
from optparse import OptionParser
import DLFCN
sys.setdlopenflags(DLFCN.RTLD_GLOBAL+DLFCN.RTLD_LAZY)
from Applications import iovInspect, iovExport, payload, globaltag,serviceMap
from Common import config
from pluginCondDBPyInterface import *

class Root(object):
    @cherrypy.expose
    def index(self):
        """ Top level page
        """
        return "This is Cond DB Application Server"

class Server(object):
    def __init__(self):
        self.__hostname='localhost'
        self.__port=6789
        self.__configfile='application.conf'

    def start (self):
        """Start server
        """
        parser=OptionParser()
        parser.add_option("--port",action="store",dest="port",
                          help="port default 6789")       
        parser.add_option("--hostname",action="store",dest="hostname",
                          help="hostname default localhost")       
        parser.add_option("--configfile",action="store",dest="configfile",
                          help="configuration file default application.conf")
        (options, args) = parser.parse_args()
        if options.hostname:
            self.__hostname=options.hostname.strip(' ')
        if options.port:
            self.__port=int(options.port)
	if options.configfile:
	    self.__configfile = options.configfile.strip(' ')
        
        serverconfig={'global':{'server.socket_host':self.__hostname,'server.socket_port':self.__port,'server.environment':'production'}}
        cherrypy.config.update(serverconfig)
        cherrypy.tree.mount(Root(),script_name='/')
        currentdir=os.path.dirname(os.path.abspath(__file__))
        appconfigfile=os.path.join(currentdir,'config',self.__configfile)
        #print 'appconfigfile',appconfigfile

        # here for the time being
        self.__config=config.Config()
        self.__config.from_ini(appconfigfile)
        self.__authpath=self.__config.iov.auth_path
        os.environ["CORAL_AUTH_PATH"] = self.__authpath
	print "auth path ", os.environ["CORAL_AUTH_PATH"]
        # this one shall be alive all the time...
        self.__cmsframe = FWIncantation()
 

        
        cherrypy.tree.mount(iovInspect.IOV(appconfigfile),script_name='/iov')
        cherrypy.tree.mount(iovExport.IOV(appconfigfile),script_name='/exportIov')
        detconfigfile=os.path.join(currentdir,'config','detector.conf')
        #print 'detconfigfile',detconfigfile
        cherrypy.tree.mount(serviceMap.serviceMap(detconfigfile),script_name='/serviceMap')
        cherrypy.tree.mount(globaltag.GlobalTag(appconfigfile),script_name='/globaltag')
        cherrypy.server.quickstart()
        cherrypy.engine.start()

if __name__ == '__main__':
    fileHandle=open('pid.txt','w')
    fileHandle.seek(0)
    mypid=os.getpid()
    fileHandle.write( str(mypid) )
    fileHandle.close()
    s=Server()
    s.start()

